#ifndef _SRCH_H_
#define _SRCH_H_

#include <ta.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef WITH_SRCH_INTERFACE
#define MAX_STRING_LENGTH	128
#define N_STRINGS_AT_ONCE       16
#define N_STRINGS_ONCE		64
#define N_STRINGS_FROM_FILE	1024
// srch
TA_STRUCT(FoundString,
	TaChar result_str[128];
	TaLong pos;
)
TA_STRUCT(SearchResults,
	TaChar pattern[128];
	TaChar file_name[128];
	TaLong start_pos;
	TaLong end_pos;
	TaLong request_number;
	FoundString *found;
)

#endif

#define MAX_STATIONS 5

int SearchServerInit(TaArea *area);

#endif
