#ifndef _WEATHER_H_
#define _WEATHER_H_

#include "ta.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

TA_STRUCT(CountryList,
	TaWChar Country[128];
	TaWChar City[128];
)
TA_STRUCT(NDSet,
	CountryList *Table;
)
// globalweather.asmx/GetCitiesByCountry
TA_STRUCT(GetCitiesByCountry,
	TaWChar CountryName[128];
	NDSet NewDataSet;
)
TA_STRUCT(CWeather,
	TaWChar Location[128];
	TaWChar Time[128];
	TaWChar Wind[128];
	TaWChar Visibility[128];
	TaWChar SkyConditions[128];
	TaFloat Temperature;
	TaFloat DewPoint;
	TaLong RelativeHumidity;
	TaWChar Pressure[64];
	TaWChar Status[32];
)
// globalweather.asmx/GetWeather
TA_STRUCT(GetWeather,
	TaWChar CityName[128];
	TaWChar CountryName[128];
	CWeather CurrentWeather;
)

#endif
