MODULE Log;
(** 
	project	= "Transparent Architecture"
	organization	= "http://sourceforge.net/"
	contributors	= "Dmitry V.Dagaev"
	license = "LGPL"
**)

	IMPORT Out;
	
	PROCEDURE String* (str: ARRAY OF CHAR);
	BEGIN
		Out.String(str);
	END String;
	
	PROCEDURE Char* (cval: CHAR);
	BEGIN
		Out.Char(cval);
	END Char;

	PROCEDURE Ln*;
	BEGIN
		Out.Ln;
	END Ln;
	
	PROCEDURE Tab*;
	BEGIN
		Out.Char(CHR(9))
	END Tab;

	PROCEDURE Int* (ival: LONGINT);
	BEGIN
		Out.Char(' '); Out.Int(ival, 0);
	END Int;
	
	PROCEDURE Real* (rval: LONGREAL);
	BEGIN
		Out.Char(' '); Out.Real (SHORT(rval), 0);
	END Real;

	PROCEDURE Bool* (bval: BOOLEAN);
	BEGIN
		Out.Char(' '); IF bval THEN Out.String('$TRUE') ELSE Out.String('$FALSE') END
	END Bool;

END Log.
